// As long as g++ has trouble with recursive templates, these may be 
// necessary.  They cover most of the user functions using double and
// complex<double> types.
// This file must be included after mMatrix.h but before any of the 
// GNUSSL include files.

/*
Copyright (C) 1996 Free Software Foundation
    written by R.D. Pierce (pierce@math.psu.edu)

This file is part of the GNUSSL software package.  This package is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This software is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this distribution; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include<mMatrix.h>
#include<complex.h>

#ifndef _instance_h_
#define _instance_h_

template class mVector<float,mi_allocator<allocator<float>,allocator<float> > >;

template class mVector<float,mu_allocator<allocator<float>,allocator<float> > >;

template class mVector<float,mu_allocator<scalar_allocator<float>,allocator<float> > >;

template class mVector<float,mu_allocator<rc_allocator<allocator<float> >,allocator<float> > >;

template class mVector<complex<double>,mi_allocator<allocator<complex<double> >, allocator<complex<double> > > >;

template class mVector<double,mi_allocator<allocator<double>,allocator<double> > >;

template class mMatrix<complex<double>,mi_allocator<allocator<complex<double> >, allocator<complex<double> > > >;

template class mVector<complex<double>,mu_allocator<rc_allocator<allocator<complex<double> > >,rc_allocator<allocator<complex<double> > > > >;

template class mVector<complex<double>,mu_allocator<scalar_allocator<complex<double> >,rc_allocator<allocator<complex<double> > > > >;

template class mMatrix<double,mi_allocator<allocator<double >, allocator<double > > >;

template class mVector<double,mu_allocator<rc_allocator<allocator<double > >,rc_allocator<allocator<double > > > >;

template class mVector<double,mu_allocator<scalar_allocator<double >,rc_allocator<allocator<double > > > >;

template class mVector<complex<double> ,mu_allocator<allocator<complex<double> >,allocator<complex<double> > > >;

template class mVector<complex<double> ,mu_allocator<rc_allocator<allocator<complex<double> > >,allocator<complex<double> > > >;

template class mVector<complex<double> ,mu_allocator<rc_allocator<allocator<complex<double> > >,rc_allocator<allocator<complex<double> > > > >;

template class mVector<double,mu_allocator<allocator<double>,allocator<double> >
 >;

template class mVector<double,mu_allocator<rc_allocator<allocator<double> >,allocator<double> > >;

template class mVector<double,mu_allocator<rc_allocator<allocator<double> >,rc_allocator<allocator<double> > > >;

template class mMatrix<double,mi_allocator<allocator<double >, allocator<double > > >;

template class mVector<double,mu_allocator<scalar_allocator<double >,allocator<double > > >;

template class mMatrix<double,mu_allocator<scalar_allocator<double >,allocator<double > > >;

template class mVector<double,mu_allocator<scalar_allocator<double >,rc_allocator<allocator<double > > > >;

template class mMatrix<double,mi_allocator<allocator<double >,mu_allocator<scalar_allocator<double >,allocator<double > > > >;

template class mVector<double,mi_allocator<allocator<double >, mu_allocator<scalar_allocator<double >,rc_allocator<allocator<double > > > > >;

template class mVector<double,mu_allocator<rc_allocator<allocator<double > >,rc_allocator<allocator<double > > > >;

template class mVector<double,mu_allocator<allocator<double >, allocator<double > > >;

template class mVector<double,mu_allocator<rc_allocator<allocator<double > >,allocator<double > > >;

template class mVector<double,mu_allocator<allocator<double >, rc_allocator<allocator<double > > > >;

template class mVector<double,mu_allocator<rc_allocator<allocator<double > >,allocator<double > > >;

template class mVector<double,u_mi_allocator<rc_allocator<allocator<double > > > >;

template class mMatrix<complex<double>,mi_allocator<allocator<complex<double> >, allocator<complex<double> > > >;

template class mVector<complex<double>,mu_allocator<scalar_allocator<complex<double> >,allocator<complex<double> > > >;

template class mMatrix<complex<double>,mu_allocator<scalar_allocator<complex<double> >,allocator<complex<double> > > >;

template class mVector<complex<double>,mu_allocator<scalar_allocator<complex<double> >,rc_allocator<allocator<complex<double> > > > >;

template class mMatrix<complex<double>,mi_allocator<allocator<complex<double> >,mu_allocator<scalar_allocator<complex<double> >,allocator<complex<double> > > > >;

template class mVector<complex<double>,mi_allocator<allocator<complex<double> >, mu_allocator<scalar_allocator<complex<double> >,rc_allocator<allocator<complex<double> > > > > >;

template class mVector<complex<double>,mu_allocator<rc_allocator<allocator<complex<double> > >,rc_allocator<allocator<complex<double> > > > >;

template class mVector<complex<double>,mu_allocator<allocator<complex<double> >, allocator<complex<double> > > >;

template class mVector<complex<double>,mu_allocator<rc_allocator<allocator<complex<double> > >,allocator<complex<double> > > >;

template class mVector<complex<double>,mu_allocator<allocator<complex<double> >, rc_allocator<allocator<complex<double> > > > >;

template class mVector<complex<double>,mu_allocator<rc_allocator<allocator<complex<double> > >,allocator<complex<double> > > >;

template class mVector<complex<double>,u_mi_allocator<rc_allocator<allocator<complex<double> > > > >;

#endif _instance_h_

